/**
 *
 *   8    .
 * ,     20,
 *    1  2 .
 *
 *  ATMega16(32)    16 .  
 *    A.
 *
 *  8- ,     .
 *   160 ,  10. 
 *
 *   20    ""  210 .     2
 * .    ,    
 * (  9-10),   ,    
 *     .
 *
 **/


#include <avr/io.h>
#include <avr/interrupt.h>
#include <stdint.h>

/**
 * ,    .      10 ,
 *          ,
 *   10. 150   , 100  200  .
 **/

uint8_t servo_position[8] = {
	100, 101, 130, 140, 150, 160, 181, 200,
};

/**
 *   
 **/

SIGNAL(SIG_OUTPUT_COMPARE0)
{
	/**
	 *  .    ""  , 
	 *   
	 **/
	static uint16_t counter = 0xFFFF;
	uint8_t tmp;
	/*   OCR0,      160  */
	OCR0 += 160;
	/*   */
	counter++;
	/*    20 */
	if (counter == 2000) {
		counter = 0;
	}
	/*
	 *     1005,     ,  
	 *   20  */
	if (counter > 1004) {
		return;
	}
	if (counter < 201) {
		/*  "" --      */
		if (counter == 0) {
			/*    ,     1 */
			PORTA |= 0x03;
		} else if (counter > 99) {
			/*   counter > 99     
			 *   1,       , 
			 *   */
			uint8_t mask = 0xFF;
			if (servo_position[0] == counter) {
				/*        -
				 * ,      */
				mask &= ~0x01;
			}
			if (servo_position[1] == counter) {
				/*        -
				 * ,      */
				mask &= ~0x02;
			}
			/*   */
			PORTA &= mask;
		}
	} else if (counter < 402) {
		/*  "" --      */
		if (counter == 201) {
			PORTA |= 0x0C;
		} else if (counter > 300) {
			tmp = counter - 201;
			uint8_t mask = 0xFF;
			if (servo_position[2] == tmp) {
				mask &= ~0x04;
			}
			if (servo_position[3] == tmp) {
				mask &= ~0x08;
			}
			PORTA &= mask;
		}
	} else if (counter < 603) {
		/*  "" */
		if (counter == 402) {
			PORTA |= 0x30;
		} else if (counter > 501) {
			tmp = counter - 402;
			uint8_t mask = 0xFF;
			if (servo_position[4] == tmp) {
				mask &= ~0x10;
			}
			if (servo_position[5] == tmp) {
				mask &= ~0x20;
			}
			PORTA &= mask;
		}
	} else if (counter < 804) {
		/*  "" */
		if (counter == 603) {
			PORTA |= 0xC0;
		} else if (counter > 702) {
			tmp = counter - 603;
			uint8_t mask = 0xFF;
			if (servo_position[6] == tmp) {
				mask &= ~0x40;
			}
			if (servo_position[7] == tmp) {
				mask &= ~0x80;
			}
			PORTA &= mask;
		}
	}
}

volatile uint32_t i;

int main(void)
{
	DDRA = 0xFF;
	TCCR0 = _BV(CS00);   /*      */
	TIMSK = _BV(OCIE0);  /*     */
	sei();
	for(;;)  {
		i++;
	}
}
