/**
 *
 *   8    .
 * ,     20,
 *    1  2 .
 *
 *  ATMega16(32)    16 .  
 *    A.
 *
 *  16- ,     
 *   8,     0,5 .  
 *  -   -   .
 *      (  
 *   OCR1B),      16.
 * 
 *    (8)    8- .
 *
 **/

#include <avr/io.h>
#include <avr/interrupt.h>


/**
 * ,    .    
 *   500,       
 *   ,   2. 3000   ,
 * 2000  4000  .
 **/
uint16_t servo_position[8] = {2000, 2200, 2400, 2600, 2800, 3000, 3200, 3412 };

volatile uint32_t i;

/**
 *   
 **/

SIGNAL(SIG_OUTPUT_COMPARE1A)
{
	/*  ,     */
	static uint8_t current_servo = 0;
	/**
	 * ,     ,  , 
	 *     8  16 .    
	 * 20,   pause.   40000, 
	 *  20.    , 
	 *     ,   
	 *      ,    20 
	 */
	static uint16_t pause = 40000;

	/*     ,    */
	PORTA = 1 << current_servo;
	if (current_servo == 8) {
		/*  current_servo  8 -    , 
		 *      20  */
		current_servo = 0;
		OCR1A += pause;
		pause = 40000;
	} else {
		/* current_servo  0  7 -    
		 *  ,   . */
		OCR1A += servo_position[current_servo];
		/*    */
		pause -= servo_position[current_servo];
		/*     */
		current_servo++;
	}
}

int main(void)
{
	DDRA = 0xFF;

	/*       */
	OCR1A = 2000;

	TCCR1A = 0;				/*       0  0xFFFF */
	TCCR1B = _BV(CS11);		/*    = 8 */
	TIMSK = _BV(OCIE1A);	/*       OCR1A */
	sei();					/*   */

	for(;;)  {
		i++;
	}
}
